//stage variables
var canvas, container;
var stage;
var imageContainer;

//touchpoint
var _touchPoint;

//settings
var xPos = 0;
var yPos = window.innerHeight/2;
var rectWidth = window.innerWidth;
var stageWidth = window.innerWidth;
var stageHeight = window.innerHeight;
var rectHeight = window.innerHeight/2;

var pointRadius = 60;

function initTouchNavigation() {
	//canvas & bg
	canvas = document.getElementById("touchCanvas");
	canvas.width = stageWidth;
	
	//stage
	stage = new Stage(canvas);

	// enable touch
	if(Touch.isSupported()) {
		Touch.enable(stage);
	}

	// enabled mouse 
	canvas.mouseEventsEnabled = true;
	
	//draw Bg
	var g = new Graphics();
	g.setStrokeStyle(2);
	g.beginStroke("#333333");
	g.beginFill("#000000");
	g.drawRoundRect( 0 , 0 , rectWidth, rectHeight-9, 10 );
	g.moveTo(0, (rectHeight)/2);
	g.lineTo(rectWidth, (rectHeight)/2);
	g.moveTo((rectWidth) / 2,0 );
	g.lineTo((rectWidth) / 2, rectHeight);
	
	var s = new Shape(g);
	s.x = xPos;
	s.y = yPos;
	stage.addChild(s);
	stage.update();

	//set ball-bitmap & handlers
	var gTouch = new Graphics();
	gTouch.setStrokeStyle(1);
	gTouch.beginStroke("#333333");
	gTouch.beginFill("#ffffff");
	gTouch.drawCircle(pointRadius / 2,pointRadius / 2,pointRadius / 2);
	
	var shapePoint = new Shape(gTouch);
	_touchPoint= new Container();
	_touchPoint.onPress = onPointPress;
	_touchPoint.addChild(shapePoint);
	_touchPoint.x = xPos + rectWidth / 2-pointRadius/2;
	_touchPoint.y = yPos + rectHeight / 2-pointRadius/2;
	stage.addChild(_touchPoint);
	stage.update();

	Ticker.setFPS(20);
	Ticker.addListener(window);
}

function onPointPress(evt) {
	var offset = {
		x : _touchPoint.x - evt.stageX,
		y : _touchPoint.y - evt.stageY
	};

	evt.onMouseMove = function(ev) {
		var currentXpos = ev.stageX + offset.x;
		var currentYpos = ev.stageY + offset.y;

		if(currentXpos > xPos && currentXpos < xPos + rectWidth -pointRadius){
			_touchPoint.x = currentXpos;
		}

		if(currentYpos > yPos && currentYpos < yPos + rectHeight -pointRadius){
			_touchPoint.y = currentYpos;
		}
		
		var forwardSpeed = - ((_touchPoint.y - yPos) - rectHeight / 2) / (rectHeight / 2);
		var sideSpeed = ((_touchPoint.x - xPos) - rectWidth / 2) / (rectWidth / 2);
		
		//send Data To Arduino
		sendDataToArduino(forwardSpeed,sideSpeed);
	}
	
	evt.onMouseUp  = onMouseUp;
}

function onMouseUp(evt) {
	var myTween = Tween.get(_touchPoint).to({x:xPos + rectWidth / 2-pointRadius/2,y:yPos + rectHeight / 2-pointRadius/2},500,Ease.bounceOut).call(onComplete);;
}

function onComplete() {
	sendDataToArduino(0,0);
}

function tick() {
	stage.update();
}